



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Java Web开发之详解JSP</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Java Web开发之详解JSP</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 22:52:22 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>JSP作为<a href="http://lib.csdn.net/base/13" rel="external nofollow noreferrer">Java Web</a>开发中比较重要的技术，一般当作视图（View）的技术所使用，即用来展现页面。Servlet由于其本身不适合作为表现层技术，所以一般被当作控制器（Controller）所使用，而JavaBean作为模型（Model）层使用。这就是经典的MVC模型。</p>
<p>Servlet和JSP的关系上篇博客已经讲过了，并演示了一个相当简单的例子。在具体讲述JSP之前，先把JavaBean简单介绍一下。</p>
<p>JavaBean其实就是一个<a href="http://lib.csdn.net/base/17" rel="external nofollow noreferrer">Java</a>普通类，定义了类的属性和行为（get、set方法）。在MVC设计模式当中，并没有提及<a href="http://lib.csdn.net/base/14" rel="external nofollow noreferrer">数据库</a>交互操作，其实就是通过JavaBean实现具体的数据库操作的。至于为什么叫JavaBean，据说还有一个故事。Java之父在一次喝咖啡的时候看到桌子上的咖啡豆，突发奇想就给起了个JavaBean的名字（Bean是豆子的意思）。</p>
<p>提到MVC，顺便说一下三层（分层、多层）<a href="http://lib.csdn.net/base/16" rel="external nofollow noreferrer">架构</a>，很多人搞不清之间的关系，感觉MVC与三层架构非常相似，认为它们没有什么太大的区别。其实用一句话概括，MVC是设计模式，而三层架构是分层模型。MVC包含模型-控制器-视图，注意这里没有&ldquo;层&rdquo;，它强调的是将开发代码分为这几个部分，通过这种模型来实现应用程序的开发。MVC也不是Web开发的专属，其实在早期的C/S开发中已经用到了MVC设计模式。而三层架构指的是DAL（数据访问层）、BLL（业务逻辑层）、UI（用户界面层），它强调的是程序开发的结构。</p>
<p>理清上面的关系，利用Java语言就可以处理后台所有相关的操作，而使用JSP就可以处理前台页面所有相关的操作。</p>
<p><strong>一、JSP基本元素</strong></p>
<p>一个JSP包含以下基本元素：</p>
<p>1、html部分</p>
<p>就是指JSP（Java Server Pages，Java服务端页面）页面的静态部分。</p>
<p>2、指令</p>
<p>主要有如下3种指令：</p>
<p>page指令（每个JSP页面都需要有，设置页面编码，导入需要jar包都需要page指令）：&lt;%@ page language="java" import="java.util.*" pageEncoding="utf-8"%&gt;</p>
<p>taglib指令（导入JSTL或者自定义标签时使用）：&lt;%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%&gt;</p>
<p>include指令（包含页面）：&lt;%@include file="test.jsp" %&gt;</p>
<p>3、表达式</p>
<p>&lt;%=方法(参数...)%&gt;</p>
<div>
<ol><li>&lt;%=getTime()&nbsp;%&gt;</li></ol>
</div>
<p>4、脚本段（scriptlet）</p>
<p>格式：&lt;%...%&gt;。比如：</p>
<div>
<ol><li>&lt;%&nbsp;Calendar&nbsp;c&nbsp;=&nbsp;Calendar.getInstance();&nbsp;%&gt;</li>
<li>&lt;%if&nbsp;(c.get(Calendar.AM_PM)&nbsp;==&nbsp;Calendar.AM)&nbsp;{%&gt;</li>
<li>上午</li>
<li>&lt;%}&nbsp;else&nbsp;{%&gt;</li>
<li>下午</li>
<li>&lt;%}%&gt;</li></ol>
</div>
<p>5、声明</p>
<p>格式：&lt;%!...%&gt; 比如：</p>
<div>
<ol><li>&lt;%!public&nbsp;String&nbsp;getTime(){</li>
<li>return&nbsp;new&nbsp;SimpleDateFormat("yyyy-MM-dd&nbsp;HH:mm:ss").format(new&nbsp;Date());</li>
<li>}&nbsp;%&gt;</li></ol>
</div>
<p>6、动作</p>
<p>使用JavaBean：&lt;jsp:useBean id="..." class="包名.类名" scope="page"/&gt;</p>
<p>获取属性：&lt;jsp:getProperty property="Bean的属性名称" name="使用的Bean的ID" /&gt;</p>
<p>设置属性：&lt;jsp:setProperty property="Bean的属性名称" name="使用的Bean的ID" value="为属性指定的显式值"/&gt;</p>
<p>页面包含：&lt;jsp:include page="test.jsp"/&gt;</p>
<p>页面跳转：&lt;jsp:forward page="test.jsp"/&gt;</p>
<p>...</p>
<p>7、注释</p>
<p>分两种注释：</p>
<p>a、&lt;!--客户端可以看到的注释--&gt;</p>
<p>b、&lt;%--客户端看不到的注释%&gt;</p>
<p>基本上上面的这7个元素，稍微复杂一点的jsp页面都会包括。这里特别提及一下，include指令和include动作的区别，两者都可以在主页面中引入别的页面，达到嵌入页面的目的。主要区别在于include指令会影响主jsp页面的构造，对主页面定义的变量会有影响，本质上是跟主页面编译为一个新的页面，因此页面执行效率更高。而include动作是将新的页面嵌入到主页面当中，在执行时会先加载主jsp页面，再加载include动作嵌入的页面，执行效率比include指令低一点，但是这是更灵活的选择。实际开发中，使用include动作更多一点。</p>
<p><strong>二、JSP隐式对象</strong></p>
<p>隐式对象的含义就是指不需要显式new一个类的对象的对象，可以在JSP页面直接使用。主要有四类：</p>
<p>1、输入输出对象：request、response、out</p>
<p>request.getParameter("name");</p>
<p>request.getParameterValues("name");</p>
<p>response.setContentType("text/html;charset=gbk");</p>
<p>response.sendRedirect("url");</p>
<p>out.println("...");</p>
<p>2、作用域对象：pageContext、request、session、appplication</p>
<p>pageContext.getAttribute("name");</p>
<p>pageContext.setAttribute("name","value");</p>
<p>request.getAttribute("name","value");</p>
<p>request.setAttribute("name","value");</p>
<p>session.getAttribute("name");</p>
<p>session.setAttribute("name","value");</p>
<p>application.getAttribute("name");</p>
<p>application.setAttribute("name","value");</p>
<p>作用域对象的生命周期：pageContext（页面）&lt;request（请求）&lt;session（会话）&lt;application（应用）。</p>
<p>3、Servlet对象：page、config</p>
<p>((HttpJspPage)page).getServletInfo();</p>
<p>config.getInitParameter("name");</p>
<p>4、错误对象：exception</p>
<p>exception.printStackTrace(out);</p>
<p><strong>三、EL表达式（表达式语言）</strong></p>
<p>虽然能够通过表达式在JSP页面嵌入Java代码实现结果输出，但是这并不是最好的开发方式。从开发角度来讲，前台JSP页面应该不出现Java代码（Java代码应该在后台出现）。为了解决这个问题，推出了JSP表达式语言。</p>
<p>语法：${...} 。</p>
<p>举个简单点的例子：</p>
<div>
<ol><li>&lt;jsp:useBean&nbsp;id="bean"&nbsp;class="com.JspPractise.bean.City"&nbsp;scope="page"/&gt;</li>
<li>&lt;jsp:setProperty&nbsp;property="name"&nbsp;name="bean"&nbsp;value="测试EL"/&gt;</li>
<li>${bean.name}&nbsp;&nbsp;&nbsp;or&nbsp;&nbsp;&nbsp;&nbsp;${bean["name"]}</li></ol>
</div>
<p>通过jsp的useBean动作使用了某个JavaBean，再通过setProperty动作给name属性赋值，最后通过${bean.name}或者${bean["name"]}输出：测试EL。</p>
<p>再比如form表单提交：</p>
<p>我们可以使用&lt;%=request.getParameter("name") %&gt;输出结果，但是更好的方式是通过${param.name}来输出。由于该作用域为page，所以也可以通过${pageScope.bean.name}EL隐式对象输出。从作用域从小到大排序其它还有requestScope、sessionScope、applicationScope等各种EL隐式对象（区别于JSP隐式对象）。</p>
<p>此外，EL表达式还有运算功能，比如：</p>
<div>
<ol><li>${10+1.0}&nbsp;&lt;!--&nbsp;11.0&nbsp;--&gt;</li>
<li>${90E2-120}&nbsp;&lt;!--&nbsp;8880.0&nbsp;--&gt;</li>
<li>${23.8*7}&nbsp;&lt;!--&nbsp;166.6&nbsp;--&gt;</li>
<li>${1/0}&nbsp;&lt;!--&nbsp;Infinity&nbsp;&nbsp;--&gt;</li>
<li>${10&nbsp;div&nbsp;5}&nbsp;&lt;!--&nbsp;2.0&nbsp;--&gt;</li>
<li>${10%4}&nbsp;&lt;!--&nbsp;2&nbsp;--&gt;</li>
<li>${10&nbsp;mod&nbsp;4}&nbsp;&lt;!--&nbsp;2&nbsp;--&gt;</li>
<li>${10*10&nbsp;eq&nbsp;100}&nbsp;&lt;!--&nbsp;true&nbsp;--&gt;</li>
<li>${'c'&nbsp;gt&nbsp;'b'}&nbsp;&lt;!--&nbsp;true&nbsp;--&gt;</li>
<li>${9&nbsp;le&nbsp;8}&nbsp;&lt;!--&nbsp;false--&gt;</li></ol>
</div>
<p><strong>四、JSTL（Java标准标签库）</strong></p>
<p>JSTL也是JSP页面中使用的技术，这套标签库设置的目的就是在JSP页面中面对一些判断（条件标签：if）、循环（迭代标签：foreach）、数据库操作（SQL标签库：update、param、query等）操作的时候，总不可避免的要嵌入Java代码，而使用这些标签则让JSP页面代码&ldquo;清爽&rdquo;了许多。除了上面的这些标签之外，还有一些通用标签，比如：set、remove、out等。</p>
<p>使用JSTL，首先要使用taglib指令，导入JSTL。</p>
<div>
<ol><li>&lt;%@taglib&nbsp;uri="http://java.sun.com/jsp/jstl/core"&nbsp;prefix="c"%&gt;</li></ol>
</div>
<p>导入之后就可以在JSP页面中使用JSTL了。</p>
<p>下面用JSTL将上面的输出&ldquo;上午/下午&rdquo;的嵌入Java代码的例子，改用JSTL实现。</p>
<div>
<ol><li>&lt;c:set&nbsp;var="cc"&nbsp;value="&lt;%=Calendar.getInstance().get(Calendar.AM_PM)%&gt;"&nbsp;/&gt;</li>
<li>&lt;c:set&nbsp;var="pm"&nbsp;value="&lt;%=Calendar.PM%&gt;"&nbsp;/&gt;</li>
<li>&lt;c:set&nbsp;var="am"&nbsp;value="&lt;%=Calendar.AM%&gt;"&nbsp;/&gt;</li>
<li>&lt;c:if&nbsp;test="${cc==am}"&gt;</li>
<li>&lt;c:out&nbsp;value="上午"&gt;&lt;/c:out&gt;</li>
<li>&lt;/c:if&gt;</li>
<li>&lt;c:if&nbsp;test="${cc==pm}"&gt;</li>
<li>&lt;c:out&nbsp;value="下午"&gt;&lt;/c:out&gt;</li>
<li>&lt;/c:if&gt;</li></ol>
</div>
<p>除了value里面的代码是Java代码之外（这里为了简单演示没有将Java代码存放到后台代码中去），再也看不到Java的身影了，取而代之的是JSTL。<br />再看看foreach标签如何使用。</p>
<div>
<ol><li>&lt;%</li>
<li>String[]&nbsp;colors&nbsp;=&nbsp;new&nbsp;String[]&nbsp;{&nbsp;"red",&nbsp;"green",&nbsp;"yellow",&nbsp;"black","silver"&nbsp;};</li>
<li>pageContext.setAttribute("colors",&nbsp;colors);</li>
<li>%&gt;</li>
<li>&lt;c:forEach&nbsp;var="color"&nbsp;items="${pageScope.colors}"&gt;</li>
<li>&lt;c:if&nbsp;test="${color=='yellow'}"&gt;</li>
<li>&lt;c:out&nbsp;value="${color}"&nbsp;/&gt;</li>
<li>&lt;/c:if&gt;</li>
<li>&lt;/c:forEach&gt;</li></ol>
</div>
<p>将一个String数组存放到了pageContext（JSP作用域对象）当中，然后通过JSTL结合EL表达式pageScope（EL作用域对象）取出并循环输出。</p>
<p>JSTL还提供了SQL标签库，由于我们开发一般都会在后台封装这部分代码，所以基本上用不着，这里也就不再演示。</p>
<p>本篇博客主要回顾了JSP开发过程中的很多基础性的细节知识，熟练掌握以上知识就能够进行Java Web开发了。当然随着项目规模的越来越大，单纯的JSP开发也不能够胜任，需要引入开发框架。著名的struts、<a href="http://lib.csdn.net/base/17" rel="external nofollow noreferrer">hibernate</a>、<a href="http://lib.csdn.net/base/17" rel="external nofollow noreferrer">spring</a>等框架我会在以后再介绍。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8krd66q.html">C&num; redis使用之ServiceStack</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kl2e3q.html">Codeforces 271 Div 2 B&period; Worms</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p57y78.html">Rewrite服务器和robots文件屏蔽动态页面</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0rk70q.html">Chrome 控制台实用指南【转】</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1lkjz9.html">Android 设计模式之观察者模式（转载自：&OpenCurlyDoubleQuote;http&colon;&sol;&sol;blog&period;csdn&period;net&sol;fangchongbory&sol;article&sol;details&sol;7774044&rdquo;）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd7olmq.html">告别LVS：使用keepalived&plus;nginx实现负载均衡代理多个https</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpmrn39.html">Oracle 游标及存储过程实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1zowgq.html">redis深入了解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7omvx18.html">记录一次Struts s2-045重大安全漏洞修复过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw53nj9.html">fastjson 操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/90ryrxm9.html">rmq区间最值</a>
		</li>
						<li><a href="https://www.batexi.com/a/8koo5o3q.html">&lbrack;加密&rsqb;SSL&sol;TLS原理详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1v4kpzq.html">IntelliJ IDEA 2017版 编译器使用学习笔记&lpar;三&rpar; &lpar;图文详尽版&rpar;&semi;IDE快捷键使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emwygj9.html">TCP协议理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rnwk3eq.html">js-验证码插件gVerify&period;js</a>
		</li>
						<li><a href="https://www.batexi.com/a/90d77rj8.html">Java 8 &colon; Predicate和Consumer接口</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2xxyp39.html">【转】TCP拥塞控制，慢启动、拥塞避免、快重传以及快恢复</a>
		</li>
						<li><a href="https://www.batexi.com/a/9g35nn4q.html">【机器学习】Boosting和Bagging的差别</a>
		</li>
						<li><a href="https://www.batexi.com/a/90d5jz48.html">uoj&num;448&period; 【集训队作业2018】人类的本质（Min&lowbar;25筛&plus;拉格朗日插值）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8md57ro8.html">sed 中如何替换换行符</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8ok2kke9.html">ORM之一：适合我的ORM</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1l1gk8.html">poj 1147 Binary codes</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xngzm8.html">从链接上获取参数值&comma; location&period;href上获取参数</a>
			</li>
						<li><a href="https://www.batexi.com/a/90v1rnj8.html">&lbrack;Effective C&plus;&plus; --012&rsqb;复制对象时勿忘其每一个成分</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4y6pm3q.html">com&period;ulitis&period;www</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxn42ed8.html">Folder and jar</a>
			</li>
						<li><a href="https://www.batexi.com/a/93x6dvz9.html">About gpref O&lpar;n2&rpar; --&amp;gt&semi; O&lpar;1&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxn4ege8.html">MSBuild编译扩展</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ok25e59.html">&lbrack;未完成&rsqb;关于枚举&lpar;Enum&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0x210q.html">【并查集】PKU-1182 食物链</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
